// Copyright 2007 John Storrs. All rights reserved. This work may be copied, 
// modified and distributed under the terms of the GNU General Public License.

#ifndef FixatorFrameClass
#define FixatorFrameClass

#include "Vector3.H"
#include "fixatorring.h"
#include "fixatorstrut.h"


class FixatorFrame
{
   public:
      FixatorFrame();
      void transformRingTo
              (const int ringId, 
               const Vector3 rotation, const Vector3 translation);
      void transformRingBy
              (const int ringId, 
               const Vector3 rotation, const Vector3 translation);
      int setStrutLengths
             (const double strutLength[6], const double approximateZ);
      void correctDeformity(double fraction);
      void emitPovraySource(ofstream &povraySource, const bool showBones);

      FixatorRing ring[2];
      FixatorStrut strut[6];
};

#endif
