
// C++ Vector and Matrix Algebra Routines from Graphics Gems IV
// Author: Jean-Francois DOUE
// Version 3.1 --- October 1993	
// Minor modifications by John Storrs

# ifndef MathsPrefix
# define MathsPrefix

// this line defines a new type: pointer to a function which returns a
// double and takes as argument a double
typedef double (*V_FCT_PTR)(double);

// min-max macros
#define MIN(A,B) ((A) < (B) ? (A) : (B))
#define MAX(A,B) ((A) > (B) ? (A) : (B))

// error handling macro
#define V_ERROR(E) { cerr << E; exit(1); }

class Vector2;
class Vector3;
class Vector4;
class Vector6;

class Matrix3;
class Matrix4;
class Matrix6;

enum {VX, VY, VZ, VW};	// axes
enum {PA, PB, PC, PD};	// planes
enum {RED, GREEN, BLUE};  // colors
enum {KA, KD, KS, ES};  // phong coefficients

#endif
