
// C++ Vector and Matrix Algebra Routines from Graphics Gems IV
// Author: Jean-Francois DOUE
// Version 3.1 --- October 1993
// Minor modifications by John Storrs

#ifndef Vector6Class
#define Vector6Class

#include <iostream>
#include <stdlib.h>
#include "MathsPrefix.H"

using namespace std;

// Vector6 Class

// JS ADDITIONS

class Vector6
{
protected:

 double n[6];

public:

// Constructors

Vector6();
Vector6(const double a, const double b, const double c, 
        const double d, const double e, const double f);
Vector6(const Vector6& v);

// Assignment operators

Vector6& operator  = ( const Vector6& v );  // assignment of a Vector6
Vector6& operator += ( const Vector6& v );  // incrementation by a Vector6
Vector6& operator -= ( const Vector6& v );  // decrementation by a Vector6
Vector6& operator *= ( const double d );  // multiplication by a constant
Vector6& operator /= ( const double d );  // division by a constant
double& operator [] ( int i);  // indexing

// Friends

friend Vector6 operator * (const Vector6& a, const double d);  // v1 * 3.0
friend Vector6 operator * (const double d, const Vector6& a);  // 3.0 * v1
friend Vector6 operator / (const Vector6& a, const double d);  // v1 / 3.0
friend void swap(Vector6& a, Vector6& b);  // swap v1 & v2

friend class Matrix6;
};

#endif
