// Copyright 2007 John Storrs. All rights reserved. This work may be copied, 
// modified and distributed under the terms of the GNU General Public License.

#ifndef FixatorStrutClass
#define FixatorStrutClass

using namespace std;

#include <fstream>

// forward declaration
class FixatorRing;

struct StrutParameters {
   double minLength;
   double maxLength;
   double diameter;
   double screwRadius;
   double screwLength;
   double nutRadius;
   double nutLength;
   double tubeRadius;
   double tubeLength;
   double jointRadius;
   double jointOffset;
   double clearance;
};

class FixatorStrut
{
   public:
      FixatorStrut() {};
      void setParameters(const int strutId, const StrutParameters &parameters);
      void connectRings(FixatorRing *ring0, FixatorRing *ring1, 
                        const int holeId0, const int holeId1);
      double length();
      bool inRange();
      void emitPovraySource(ofstream &povraySource);

      int id;  // 0..5
      StrutParameters parameters;
      FixatorRing *ring[2];
};

#endif
